﻿using UnityEngine;
using System.Collections;

public class DoorManager : MonoBehaviour 
{
	public GameObject DoorPrefab;
	static GameObject drPrefab;

	public GameObject WallPrefab;
	static GameObject wlPrefab;

	void Start()
	{
		drPrefab = DoorPrefab;
		wlPrefab = WallPrefab;
	}

	public static void SpawnDoor(GameObject tile, TileDirection dir)
	{
		//instantiate
		GameObject door = Instantiate (drPrefab, tile.transform.position, tile.transform.rotation) as GameObject; 
		door.transform.parent = tile.transform;

		//rotate
		if (dir == TileDirection.Left || dir == TileDirection.Right)
			door.transform.Rotate (tile.transform.forward, 90f);

		//move
		switch(dir)
		{
		case(TileDirection.Left):
		{
			door.transform.localPosition = new Vector3(-0.5f,0,0);
		}
			break;
		case(TileDirection.Down):
		{
			door.transform.localPosition = new Vector3(0,-0.5f,0);
		}
			break;
		case(TileDirection.Up):
		{
			door.transform.localPosition = new Vector3(0,0.5f,0);
		}
			break;
		case(TileDirection.Right):
		{
			door.transform.localPosition = new Vector3(0.5f,0,0);
		}
			break;
		}
	}

	public static void SpawnWall(GameObject tile, TileDirection dir)
	{
		//instantiate
		GameObject wall = Instantiate (wlPrefab, tile.transform.position, tile.transform.rotation) as GameObject; 
		wall.transform.parent = tile.transform;
		
		//rotate
		if (dir == TileDirection.Left || dir == TileDirection.Right)
			wall.transform.Rotate (tile.transform.forward, 90f);
		
		//move
		switch(dir)
		{
		case(TileDirection.Left):
		{
			wall.transform.localPosition = new Vector3(-0.5f,0,0);
		}
			break;
		case(TileDirection.Down):
		{
			wall.transform.localPosition = new Vector3(0,-0.5f,0);
		}
			break;
		case(TileDirection.Up):
		{
			wall.transform.localPosition = new Vector3(0,0.5f,0);
		}
			break;
		case(TileDirection.Right):
		{
			wall.transform.localPosition = new Vector3(0.5f,0,0);
		}
			break;
		}
	}
}
