﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class GameManager : MonoBehaviour 
{

	public static GameManager instance;

	public static int P1_AP; public static int P2_AP; public static int P3_AP; public static int P4_AP;
	public static bool UI_EndTurnIconOn;
	public static bool noMoreMoves;

	public int AP_Hacker;
	public int AP_Corp;

	public static int Rounds = 0;
	public string Round = "1";

	public static int TerminalsInPlay = 0;

	public static bool MainframeInPlay = false;
	public string Mainframe = "";
	public Vector2 MainframeCoords;

	[Range(0,100)]
	public int Probability_SecondDoor = 75;
	[Range(0,100)]
	public int Probability_ThirdDoor = 50;
	[Range(0,100)]
	public int Probability_FourthDoor = 25;
	[Range(0,100)]
	public int Probability_Terminal = 10;
	[Range(0,100)]
	public int Probability_Mainframe = 0;

	public GameObject newRoundDisplay;
	private string newRoundText;
	Text roundText;
	
	void Start () 
	{
		instance = this;
	
		noMoreMoves = false;
		UI_EndTurnIconOn = false;

		Rounds = 1;

		roundText = newRoundDisplay.GetComponent<Text> ();

		ResetAP ();
		DisplayNewRound ();

		Mainframe = "non";
	}
	
	// Update is called once per frame
	void Update () {
		if(noMoreMoves)
		{
			UI_EndTurnIconOn = true;
		}
		else if(!noMoreMoves)
		{
			UI_EndTurnIconOn = false;
		}
	}

	public void ResetAP()
	{
		P1_AP = instance.AP_Hacker;
		P2_AP = instance.AP_Corp;
		P3_AP = instance.AP_Corp;
		P4_AP = instance.AP_Corp;
	}

	public void RoundOver()
	{
		Rounds++;
		Round = Rounds.ToString ();

		switch(Rounds)
		{
		case(2):
		{
			Probability_Terminal += 10;
		}
			break;
		case(3):
		{
			if(MainframeInPlay == false)
				Probability_Mainframe += 10;
		}
			break;
		case(4):
		{
			Probability_Terminal += 10;
			if(MainframeInPlay == false)
				Probability_Mainframe += 10;
		}
			break;
		case(5):
		{

			if(MainframeInPlay == false)
				Probability_Mainframe += 10;
		}
			break;
		case(6):
		{
			Probability_Terminal += 10;
		}
			break;
		case(7):
		{
		}
			break;
		case(8):
		{
		}
			break;
		case(9):
		{
		}
			break;
		}

		if(MainframeInPlay)
			Probability_Mainframe = 0;

		DisplayNewRound ();
		SoundManager.instance.RoundChange ();
	}

	void DisplayNewRound()
	{
		newRoundText = "ROUND " + Round;
		roundText.text = newRoundText;
		newRoundDisplay.SetActive (true);
		StartCoroutine ("ShowRoundText");
	}

	IEnumerator ShowRoundText()
	{
		yield return new WaitForSeconds (2.0f);
		newRoundDisplay.SetActive (false);
	}
}
