#if UNITY_EDITOR
using UnityEngine;
using UnityEditor;

using System.Collections;

//http://answers.unity3d.com/questions/148812/is-there-a-toggle-for-snap-to-grid.html

[ExecuteInEditMode]
class AutoSnap : EditorWindow
{
    Vector3 prevPosition;
	Quaternion prevRotation;
    bool doSnap = false;
	bool doSnapRot = false;
    float snapValue = 1;
	float snapRotValue = 90;
    
	[MenuItem("Edit/Auto Snap Window")]
    static void Init () 
    {
		EditorWindow.GetWindow(typeof(AutoSnap));
    }

    void OnGUI()
    {
        doSnap = EditorGUILayout.Toggle("Autosnap", doSnap);
        snapValue = EditorGUILayout.FloatField("Snap Value", snapValue);
		
		doSnapRot = EditorGUILayout.Toggle("Autosnap Rotation", doSnapRot);
		snapRotValue = EditorGUILayout.FloatField("Rotation Snap Value",snapRotValue);
    }

    void Update()
    {
        if(Selection.transforms.Length > 0 && !EditorApplication.isPlaying)
		{
			if (Selection.transforms[0].position != prevPosition)
			{
			  if(doSnap)
      	      	snap();
			}
			if (Selection.transforms[0].rotation != prevRotation)
			{
				if (doSnapRot)
					snapRot();	
			}
		}
    }

    void snap()
    {
        for(int i = 0; i < Selection.transforms.Length; i++)
        {               
           Vector3 t = Selection.transforms[i].transform.position;       
            t.x = round(t.x);
            t.y = round(t.y);
            t.z = round(t.z);
			
            Selection.transforms[i].transform.position = t;
        }
        prevPosition = Selection.transforms[0].position;
    }
	
    void snapRot()
    {
        for(int i = 0; i < Selection.transforms.Length; i++)
        {
			Vector3 tLocalEuler = Selection.transforms[i].localEulerAngles;
			
			tLocalEuler.x = roundRot(tLocalEuler.x);
			tLocalEuler.y = roundRot(tLocalEuler.y);
			tLocalEuler.z = roundRot(tLocalEuler.z);
			
 			Selection.transforms[i].transform.localEulerAngles = tLocalEuler;
        }
        prevRotation = Selection.transforms[0].rotation;
    }
	
    float round(float input)
    {
        float snappedValue;

        snappedValue = snapValue * Mathf.Round((input / snapValue));

        return(snappedValue);
    }
	
	float roundRot(float input)
    {
        float snappedValue;

        snappedValue = snapRotValue * Mathf.Round((input / snapRotValue));

        return(snappedValue);
    }
}
#endif